<template>
  <div class="form mt-2">
    <form @submit.prevent="submitForm">
      <div class="row">
        <div class="col-sm-12 col-md-6">
          <div class="form-group">
            <label class="mb-2">Account From:</label>
            <select
              v-model="form.accountFrom"
              class="form-select"
              v-validate="'required'"
              name="Account From"
            >
              <option
                v-for="(account, i) in accounts"
                :key="i"
                :value="account"
              >
                {{ `${account.AccountType} - ${account.AccountNumber}` }}
              </option>
            </select>
            <div v-show="verrors.has('Account From')" class="invalid-feedback">
              {{ verrors.first('Account From') }}
            </div>
          </div>
          <div class="form-group mt-2">
            <label class="mb-2">TO:</label>
            <select
              v-model="form.accountTo"
              class="form-select"
              v-validate="'required'"
              name="To"
            >
              <option :value="null">Select Account To</option>
              <option
                v-for="(account, i) in accounts"
                :key="i"
                :value="account"
              >
                {{ `${account.AccountType} - ${account.AccountNumber}` }}
              </option>
            </select>
            <div v-show="verrors.has('To')" class="invalid-feedback">
              {{ verrors.first('To') }}
            </div>
          </div>
          <div class="form-group mt-3">
            <label class="mb-2">Amount</label>
            <div class="input-group">
              <span
                class="input-group-text border-0 text-dark fw-bold"
                style="background: #f4f2ec"
                >N</span
              >

              <currency-input
                v-model="form.amount"
                v-validate="'required|decimal'"
                currency="NGN"
                class="form-control"
                type="text"
                name="Amount"
              />
            </div>
            <div v-show="verrors.has('Amount')" class="invalid-feedback">
              {{ verrors.first('Amount') }}
            </div>
          </div>
        </div>
        <div class="col-sm-12 col-md-6">
          <div class="form-group">
            <label class="mb-2">Note (optional)</label>
            <textarea
              v-model="form.note"
              rows="5"
              class="form-control"
            ></textarea>
          </div>
          <div class="form-group">
            <label class="mb-2">Transaction PIN</label>

            <input
              type="password"
              v-model="form.pin"
              class="form-control"
              v-validate="'required'"
              name="Transaction PIN"
            />
            <div
              v-show="verrors.has('Transaction PIN')"
              class="invalid-feedback"
            >
              {{ verrors.first('Transaction PIN') }}
            </div>
          </div>
          <div class="mt-3">
            <div class="d-flex justify-content-between">
              <!-- <button
                class="btn btn-light btn-lg rounded-1 px-4"
                style="font-size: 14px"
              >
                Cancel
              </button> -->
              <!-- <button
                class="btn btn-primary btn-lg rounded-1 px-4 h6"
                type="button"
                style="font-size: 14px"
                data-bs-toggle="modal"
                data-bs-target="#TransferSuccessCreationModal"
              >

              </button> -->
              <vs-button :loading="form.active" type="submit" class="px-5">
                Transfer
              </vs-button>
            </div>
          </div>
        </div>
        <div class="col-sm-12 col-md-6"></div>
      </div>
    </form>

    <!-- Modals -->
    <!-- Successful Transfer Modal -->
    <div
      class="modal fade"
      id="TransferSuccessCreationModal"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
            <div class="text-center">
              <img
                src="@/assets/images/transfer-success-icon.png"
                alt="Transfer Successfull"
              />
            </div>
            <div class="px-5 text-center mt-3">
              <h3 class="fw-bold text-dark my-2">Transfer Successful!</h3>
              <p class="text-muted my-2 px-3">
                Congratulations, your transfer was completed successfully!
              </p>

              <div class="mt-3">
                <div class="row">
                  <div class="col-sm-12 col-md-12">
                    <div
                      class="bg-light p-3 text-left"
                      style="text-align: left !important"
                    >
                      <h5 class="fw-bold">{{ form.amount | formatPrice }}</h5>
                      <p class="text-muted m-0" style="font-size: 10px">
                        * Note that the transfer might take a few minutes to
                        reflect
                      </p>
                    </div>
                  </div>
                </div>
              </div>

              <!-- <div class="mt-3">
                <div class="d-flex justify-content-between">
                  <button
                    class="btn btn-light btn-lg rounded-1 px-4"
                    style="font-size: 14px"
                  >
                    Download Receipts
                  </button>
                  <button
                    class="btn btn-primary btn-lg rounded-1 px-5 h6"
                    type="button"
                    style="font-size: 14px"
                    data-bs-toggle="modal"
                    data-bs-target="#TransferSuccessCreationModal"
                  >
                    <span class="px-2"> OK </span>
                  </button>
                </div>
              </div>
              <div class="mt-3">
                <p class="text-primary fw-bold">
                  Save Recipient as Beneficiary
                </p>
              </div> -->
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- Successful Transfer Modal -->
    <div
      class="modal fade"
      id="TransactionPromptModal"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
            <div class="text-center">
              <img
                src="@/assets/images/transfer-success-icon.png"
                alt="Transfer Successfull"
              />
            </div>
            <div class="px-5 text-center mt-3">
              <h3 class="fw-bold text-dark my-2">Transfer Successful!</h3>
              <p class="text-muted my-2 px-3">
                Congratulations, your transfer was completed successfully!
              </p>

              <div class="mt-3">
                <div class="row">
                  <div class="col-sm-12 col-md-12">
                    <div
                      class="bg-light p-3 text-left"
                      style="text-align: left !important"
                    >
                      <h5 class="fw-bold">{{ form.amount | formatPrice }}</h5>
                      <p class="text-muted m-0" style="font-size: 10px">
                        * Note that the transfer might take a few minutes to
                        reflect
                      </p>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    accounts: {
      required: true,
      default: [],
    },
  },
  data: () => ({
    form: {
      active: false,
      accountFrom: {},
      accountTo: null,
    },
  }),
  created() {
    // console.log(this.accounts)
    this.form.accountFrom = this.accounts[0]
  },
  mounted() {
    // eslint-disable-next-line
    // const modal = new bootstrap.Modal(
    //   document.getElementById('TransactionPromptModal'),
    //   {}
    // )
    // modal.show()
  },
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    submitForm() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          console.log(this.form)
          const data = {
            accountToDebit: this.form.accountFrom.AccountNumber,
            amount: String(this.form.amount),
            transactionPin: this.form.pin,
            beneficiaryAccountNumber: this.form.accountTo.AccountNumber,
          }
          this.form.active = true
          this.$axios
            .post('/user/corebank-transfer', data)
            .then(({ data }) => {
              console.log(data)
              this.form.active = false
              // eslint-disable-next-line
              const modal = new bootstrap.Modal(
                document.getElementById('TransferSuccessCreationModal'),
                {}
              )
              modal.show()
            })
            .catch((error) => {
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
  },
}
</script>
